camel-dev mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From "Hendy Irawan (JIRA)" <j...@apache.org>
Subject [jira] Commented: (CAMEL-775) camel osgi DynamicImport-Package
Date Fri, 01 Aug 2008 11:27:00 GMT

    [ https://issues.apache.org/activemq/browse/CAMEL-775?page=com.atlassian.jira.plugin.system.issuetabpanels:comment-tabpanel&focusedCommentId=44681#action_44681
] 

Hendy Irawan commented on CAMEL-775:
------------------------------------

To me the answer is clear:

[SpringOsgiExtenderThread-2] DEBUG org.apache.camel.util.ResolverUtil - Could not find class
'org/apache/camel/converter/ObjectConverter.class' in classloader: BundleDelegatingClassLoader
for [org.elfattah.shell (org.elfattah.shell)]. Reason: java.lang.ClassNotFoundException: org.apache.camel.converter.ObjectConverter
not found from bundle [org.elfattah.shell]

Question is, what ResolverUtils wants to do?

org.apache.camel.converter.ObjectConverter is definitely not in our (org.elfattah.shell)'s
import package.... therefore it should not be accessible from there anyway. And we don't have
any code that uses that class explicitly. Which means ResolverUtil's hands is dirty...

ResolverUtil should know which classloader it wants to load a class from.

Or use a classloader that has "Import-Package: org.apache.camel.converter"

> camel osgi DynamicImport-Package
> --------------------------------
>
>                 Key: CAMEL-775
>                 URL: https://issues.apache.org/activemq/browse/CAMEL-775
>             Project: Apache Camel
>          Issue Type: Sub-task
>          Components: camel-core, camel-osgi
>    Affects Versions: 1.4.0
>            Reporter: Claus Ibsen
>             Fix For: 1.5.0
>
>
> See parent issue.
> Thanks Claus. I hope this can help getting it resolved. Let me know if it is, even a
snapshot will do very well for us.
> Another question, is below "DynamicImport-Package workaround" supposed to be bug? Or
it's just the way Camel needs to be configured on OSGi? If so it should be mentioned somewhere
in the docs... not everybody knows that DynamicImport-Package even exists.. (even some OSGi
programmers)
> First of all, to even get this to "work" requires my own bundle to have this manifest:
> DynamicImport-Package: org.apache.camel.*
> Failing to do so will result in more classloading errors.

-- 
This message is automatically generated by JIRA.
-
You can reply to this email to add a comment to the issue online.


Mime
View raw message